Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.collect
Interface Multiset<E>

All Superinterfaces:
  Collection<E>, Iterable<E>

All Known Implementing Classes:
  ConcurrentHashMultiset, EnumMultiset, ForwardingMultiset, HashMultiset, ImmutableMultiset, LinkedHashMultiset, TreeMultiset

    public interface Multiset<E>

extends Collection<E>

A collection that supports order-independent equality, like `Set`, but may have duplicate elements. A multiset is also sometimes called a bag.

Elements of a multiset that are equal to one another (see "Note on element equivalence", below) are referred to as occurrences of the same single element. The total number of occurrences of an element in a multiset is called the count of that element (the terms "frequency" and "multiplicity" are equivalent, but not used in this API). Since the count of an element is represented as an `int`, a multiset may never contain more than `Integer.MAX_VALUE` occurrences of any one element.

`Multiset` refines the specifications of several methods from `Collection`. It also defines an additional query operation, `count(java.lang.Object)`, which returns the count of an element. There are five new bulk-modification operations, for example `add(Object, int)`, to add or remove multiple occurrences of an element at once, or to set the count of an element to a specific value. These modification operations are optional, but implementations which support the standard collection operations `add(Object)` or `remove(Object)` are encouraged to implement the related methods as well. Finally, two collection views are provided: `elementSet()` contains the distinct elements of the multiset "with duplicates collapsed", and `entrySet()` is similar but contains `Multiset.Entry` instances, each providing both a distinct element and the count of that element.

In addition to these required methods, implementations of `Multiset` are expected to provide two `static` creation methods: `create()`, returning an empty multiset, and `create(Iterable<? extends E>)`, returning a multiset containing the given initial elements. This is simply a refinement of `Collection`'s constructor recommendations, reflecting the new developments of Java 5.

As with other collection types, the modification operations are optional, and should throw `UnsupportedOperationException` when they are not implemented. Most implementations should support either all add operations or none of them, all removal operations or none of them, and if and only if all of these are supported, the `setCount` methods as well.

A multiset uses `Object.equals(java.lang.Object)` to determine whether two instances should be considered "the same," unless specified otherwise by the implementation.

Author:
  Kevin Bourrillion

Nested Class Summary
`static interface` | `Multiset.Entry<E>` An unmodifiable element-count pair for a multiset.

Method Summary
`boolean` | `add(E element)` Adds a single occurrence of the specified element to this multiset.
`int` | `add(E element, int occurrences)` Adds a number of occurrences of an element to this multiset.
`boolean` | `contains(Object element)` Determines whether this multiset contains the specified element.
`boolean` | `containsAll(Collection<?> elements)` Returns `true` if this multiset contains at least one occurrence of each element in the specified collection.
`int` | `count(Object element)` Returns the number of occurrences of an element in this multiset (the count of the element).
`Set<E>` | `elementSet()` Returns the set of distinct elements contained in this multiset.
`Set<Multiset.Entry<E>>` | `entrySet()` Returns a view of the contents of this multiset, grouped into `Multiset.Entry` instances, each providing an element of the multiset and the count of that element.
`boolean` | `equals(Object object)` Compares the specified object with this multiset for equality.
`int` | `hashCode()` Returns the hash code for this multiset.
`Iterator<E>` | `iterator()` Returns an iterator over the elements in this collection.
`boolean` | `remove(Object element)` Removes a single occurrence of the specified element from this multiset, if present.
`int` | `remove(Object element, int occurrences)` Removes a number of occurrences of the specified element from this multiset.
`boolean` | `removeAll(Collection<?> c)` Removes all of this collection's elements that are also contained in the specified collection (optional operation).
`boolean` | `retainAll(Collection<?> c)` Retains only the elements in this collection that are contained in the specified collection (optional operation).
`int` | `setCount(E element, int count)` Adds or removes the necessary occurrences of an element such that the element attains the desired count.
`boolean` | `setCount(E element, int oldCount, int newCount)` Conditionally sets the count of an element to a new value, as described in `setCount(Object, int)`, provided that the element has the expected current count.
`String` | `toString()` Returns a string representation of the object.

Methods inherited from interface java.util.Collection
`addAll, clear, isEmpty, size, toArray, toArray`

Method Detail

### count

    int count(@Nullable
              Object element)

  Returns the number of occurrences of an element in this multiset (the count of the element). Note that for an `Object.equals(java.lang.Object)`-based multiset, this gives the same result as `Collections.frequency(java.util.Collection, java.lang.Object)` (which would presumably perform more poorly).

  Note: the utility method `Iterables.frequency(java.lang.Iterable, java.lang.Object)` generalizes this operation; it correctly delegates to this method when dealing with a multiset, but it can also accept any other iterable type.

  Parameters:
    `element` - the element to count occurrences of
  Returns:
    the number of occurrences of the element in this multiset; possibly zero but never negative

### add

    int add(@Nullable
            E element,
            int occurrences)

  Adds a number of occurrences of an element to this multiset. Note that if `occurrences == 1`, this method has the identical effect to `add(Object)`. This method is functionally equivalent (except in the case of overflow) to the call `addAll(Collections.nCopies(element, occurrences))`, which would presumably perform much more poorly.

  Parameters:
    `element` - the element to add occurrences of; may be `null` only if explicitly allowed by the implementation
    `occurrences` - the number of occurrences of the element to add. May be zero, in which case no change will be made.
  Returns:
    the count of the element before the operation; possibly zero
  Throws:
    `IllegalArgumentException` - if `occurrences` is negative, or if this operation would result in more than `Integer.MAX_VALUE` occurrences of the element
    `NullPointerException` - if `element` is null and this implementation does not permit null elements. Note that if `occurrences` is zero, the implementation may opt to return normally.

### remove

    int remove(@Nullable
               Object element,
               int occurrences)

  Removes a number of occurrences of the specified element from this multiset. If the multiset contains fewer than this number of occurrences to begin with, all occurrences will be removed. Note that if `occurrences == 1`, this is functionally equivalent to the call `remove(element)`.

  Parameters:
    `element` - the element to conditionally remove occurrences of
    `occurrences` - the number of occurrences of the element to remove. May be zero, in which case no change will be made.
  Returns:
    the count of the element before the operation; possibly zero
  Throws:
    `IllegalArgumentException` - if `occurrences` is negative

### setCount

    int setCount(E element,
                 int count)

  Adds or removes the necessary occurrences of an element such that the element attains the desired count.

  Parameters:
    `element` - the element to add or remove occurrences of; may be null only if explicitly allowed by the implementation
    `count` - the desired count of the element in this multiset
  Returns:
    the count of the element before the operation; possibly zero
  Throws:
    `IllegalArgumentException` - if `count` is negative
    `NullPointerException` - if `element` is null and this implementation does not permit null elements. Note that if `count` is zero, the implementor may optionally return zero instead.

### setCount

    boolean setCount(E element,
                     int oldCount,
                     int newCount)

  Conditionally sets the count of an element to a new value, as described in `setCount(Object, int)`, provided that the element has the expected current count. If the current count is not `oldCount`, no change is made.

  Parameters:
    `element` - the element to conditionally set the count of; may be null only if explicitly allowed by the implementation
    `oldCount` - the expected present count of the element in this multiset
    `newCount` - the desired count of the element in this multiset
  Returns:
    `true` if the condition for modification was met. This implies that the multiset was indeed modified, unless `oldCount == newCount`.
  Throws:
    `IllegalArgumentException` - if `oldCount` or `newCount` is negative
    `NullPointerException` - if `element` is null and the implementation does not permit null elements. Note that if `oldCount` and `newCount` are both zero, the implementor may optionally return `true` instead.

### elementSet

    Set<E> elementSet()

  Returns the set of distinct elements contained in this multiset. The element set is backed by the same data as the multiset, so any change to either is immediately reflected in the other. The order of the elements in the element set is unspecified.

  If the element set supports any removal operations, these necessarily cause all occurrences of the removed element(s) to be removed from the multiset. Implementations are not expected to support the add operations, although this is possible.

  A common use for the element set is to find the number of distinct elements in the multiset: `elementSet().size()`.

  Returns:
    a view of the set of distinct elements in this multiset

### entrySet

    Set<Multiset.Entry<E>> entrySet()

  Returns a view of the contents of this multiset, grouped into `Multiset.Entry` instances, each providing an element of the multiset and the count of that element. This set contains exactly one entry for each distinct element in the multiset (thus it always has the same size as the `elementSet()`). The order of the elements in the element set is unspecified.

  The entry set is backed by the same data as the multiset, so any change to either is immediately reflected in the other. However, multiset changes may or may not be reflected in any `Entry` instances already retrieved from the entry set (this is implementation-dependent). Furthermore, implementations are not required to support modifications to the entry set at all, and the `Entry` instances themselves don't even have methods for modification. See the specific implementation class for more details on how its entry set handles modifications.

  Returns:
    a set of entries representing the data of this multiset

### equals

    boolean equals(@Nullable
                   Object object)

  Compares the specified object with this multiset for equality. Returns `true` if the given object is also a multiset and contains equal elements with equal counts, regardless of order.

  Specified by:
    `equals` in interface `Collection<E>`
  Overrides:
    `equals` in class `Object`
  Parameters:
    `object` - the reference object with which to compare.
  Returns:
    `true` if this object is the same as the obj argument; `false` otherwise.
  See Also:
    `Object.hashCode()`, `Hashtable`

### hashCode

    int hashCode()

  Returns the hash code for this multiset. This is defined as the sum of

        (element == null ? 0 : element.hashCode()) ^ count(element)

  over all distinct elements in the multiset. It follows that a multiset and its entry set always have the same hash code.

  Specified by:
    `hashCode` in interface `Collection<E>`
  Overrides:
    `hashCode` in class `Object`
  Returns:
    a hash code value for this object.
  See Also:
    `Object.equals(java.lang.Object)`, `Hashtable`

### toString

    String toString()

  Returns a string representation of the object. In general, the `toString` method returns a string that "textually represents" this object. The result should be a concise but informative representation that is easy for a person to read. It is recommended that all subclasses override this method.

  The `toString` method for class `Object` returns a string consisting of the name of the class of which the object is an instance, the at-sign character ``@`', and the unsigned hexadecimal representation of the hash code of the object. In other words, this method returns a string equal to the value of:

  >      getClass().getName() + '@' + Integer.toHexString(hashCode())

  It is recommended, though not mandatory, that this method return the result of invoking `toString()` on the `entrySet()`, yielding a result such as

           [a x 3, c, d x 2, e]

  Overrides:
    `toString` in class `Object`
  Returns:
    a string representation of the object.

### iterator

    Iterator<E> iterator()

  Returns an iterator over the elements in this collection. There are no guarantees concerning the order in which the elements are returned (unless this collection is an instance of some class that provides a guarantee).

  Elements that occur multiple times in the multiset will appear multiple times in this iterator, though not necessarily sequentially.

  Specified by:
    `iterator` in interface `Collection<E>`
  Specified by:
    `iterator` in interface `Iterable<E>`
  Returns:
    an `Iterator` over the elements in this collection

### contains

    boolean contains(@Nullable
                     Object element)

  Determines whether this multiset contains the specified element.

  This method refines `Collection.contains(java.lang.Object)` to further specify that it may not throw an exception in response to `element` being null or of the wrong type.

  Specified by:
    `contains` in interface `Collection<E>`
  Parameters:
    `element` - the element to check for
  Returns:
    `true` if this multiset contains at least one occurrence of the element

### containsAll

    boolean containsAll(Collection<?> elements)

  Returns `true` if this multiset contains at least one occurrence of each element in the specified collection.

  This method refines `Collection.containsAll(java.util.Collection)` to further specify that it may not throw an exception in response to any of `elements` being null or of the wrong type.

  Note: this method does not take into account the occurrence count of an element in the two collections; it may still return `true` even if `elements` contains several occurrences of an element and this multiset contains only one. This is no different than any other collection type like `List`, but it may be unexpected to the user of a multiset.

  Specified by:
    `containsAll` in interface `Collection<E>`
  Parameters:
    `elements` - the collection of elements to be checked for containment in this multiset
  Returns:
    `true` if this multiset contains at least one occurrence of each element contained in `elements`
  Throws:
    `NullPointerException` - if `elements` is null
  See Also:
    `Collection.contains(Object)`

### add

    boolean add(E element)

  Adds a single occurrence of the specified element to this multiset.

  This method refines `Collection.add(E)`, which only ensures the presence of the element, to further specify that a successful call must always increment the count of the element, and the overall size of the collection, by one.

  Specified by:
    `add` in interface `Collection<E>`
  Parameters:
    `element` - the element to add one occurrence of; may be null only if explicitly allowed by the implementation
  Returns:
    `true` always, since this call is required to modify the multiset, unlike other `Collection` types
  Throws:
    `NullPointerException` - if `element` is null and this implementation does not permit null elements
    `IllegalArgumentException` - if `Integer.MAX_VALUE` occurrences of `element` are already contained in this multiset

### remove

    boolean remove(@Nullable
                   Object element)

  Removes a single occurrence of the specified element from this multiset, if present.

  This method refines `Collection.remove(java.lang.Object)` to further specify that it may not throw an exception in response to `element` being null or of the wrong type.

  Specified by:
    `remove` in interface `Collection<E>`
  Parameters:
    `element` - the element to remove one occurrence of
  Returns:
    `true` if an occurrence was found and removed

### removeAll

    boolean removeAll(Collection<?> c)

  Removes all of this collection's elements that are also contained in the specified collection (optional operation). After this call returns, this collection will contain no elements in common with the specified collection.

  This method refines `Collection.removeAll(java.util.Collection)` to further specify that it may not throw an exception in response to any of `elements` being null or of the wrong type.

  Specified by:
    `removeAll` in interface `Collection<E>`
  Parameters:
    `c` - collection containing elements to be removed from this collection
  Returns:
    `true` if this collection changed as a result of the call
  See Also:
    `Collection.remove(Object)`, `Collection.contains(Object)`

### retainAll

    boolean retainAll(Collection<?> c)

  Retains only the elements in this collection that are contained in the specified collection (optional operation). In other words, removes from this collection all of its elements that are not contained in the specified collection.

  This method refines `Collection.retainAll(java.util.Collection)` to further specify that it may not throw an exception in response to any of `elements` being null or of the wrong type.

  Specified by:
    `retainAll` in interface `Collection<E>`
  Parameters:
    `c` - collection containing elements to be retained in this collection
  Returns:
    `true` if this collection changed as a result of the call
  See Also:
    `Collection.remove(Object)`, `Collection.contains(Object)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD